package wifky::yangwords;

$::preferences{'Yet Another NG-Words Plugin 0.1'} = [
  {
      desc=>'Only administrator can write ng words.' ,
      name=>'yangwords_admin_ok' ,
      type=>'checkbox' ,
  },
  {
      desc=>'NG Words',
      name=>'yangwords',
      type=>'textarea',
      rows=>20,
  }
];

my $action_comment_orig = $::action_plugin{'comment'};
if( !&::is_signed() || !$::config{yangwords_admin_ok} ){
    (*::do_submit , *org_submit ) = (*new_submit , *::do_submit);
    $::action_plugin{'comment'} = \&new_comment;
}

sub new_submit{
    if( defined(my $item=&found_ng( \$::form{text_t})) ){
        die(qq{!Your subject has NG word: "$item".!});
    }
    &org_submit(@_);
};

sub new_comment{
    foreach my $text ( \$::form{'who'} , \$::form{'comment'} ){
        if( defined(my $item=&found_ng($text)) ){
            die(qq{!Your comment has NG word: "$item".!});
        }
    }
    $action_comment_orig->();
};

sub found_ng{
    my $text=shift;
    my @list = split(/\s+/,$::config{yangwords} || '');
    foreach my $item (@list) {
        if( index($$text,$item) >= 0 ){
            return $item;
        }
    }
    undef;
}

1;
